<?php defined('SYSPATH') or die('No direct script access.');

class Model_Teachers extends Model
{
    public static function getJobPositions() {
        $sql = "CALL `GetJobPositions`()";
        return DB::query(Database::SELECT, $sql)->execute()->as_array();
    }

    public static function ofFaculty($facultyID) {
        $sql = "CALL `GetTeachersByFaculty`(:faculty)";
        return DB::query(Database::SELECT, $sql)
            ->param(':faculty', $facultyID)
            ->execute();
    }

    public static function ofDepartment($departmentID) {
        $sql = "CALL `GetTeachersByDepartment`(:id)";
        return DB::query(Database::SELECT, $sql)
            ->param(':id', $departmentID)
            ->execute();
    }

    // todo: does it make search among all teachers?
    public static function search($facultyID, $departmentID, $name, $disciplineID) {
        $sql = "CALL `SearchTeachers`(:faculty, :department, :name, :discipline)";
        return DB::query(Database::SELECT, $sql)
            ->parameters([
                ':name'       => $name,
                ':faculty'    => $facultyID,
                ':department' => $departmentID,
                ':discipline' => $disciplineID,
            ])->execute()->as_array();
    }

    public static function searchTeacherNew($facultyID, $departmentID, $last, $first, $second, $disciplineID) {
        $sql = "CALL `SearchTeacherNew`(:faculty, :department, :last, :first, :second, :discipline)";
        return DB::query(Database::SELECT, $sql)
            ->parameters([
                ':faculty'    => $facultyID,
                ':department' => $departmentID,
                ':discipline' => $disciplineID,
                ':last'       => $last,
                ':first'      => $first,
                ':second'     => $second,
            ])->execute();
    }
}